import java.awt.*;
import java.applet.*;
import java.awt.event.*;

/** 
 * Assignment 6 for 415.101FC 2000
 * DO NOT CHANGE THIS CODE IN ANY WAY.
 * @author  Robert Sheehan
 * @version 2000.03.22
 */
public class A6 extends Applet implements ActionListener {

  /** Student one. */
  private Student one;
  /** Student two. */
  private Student two;
  /** Student three. */
  private Student three;
  /** Student four. */
  private Student four;
  /** Student five. */
  private Student five;
  /** Student six. */
  private Student six;
  /** Button for student one. */
  private Button buttonOne;
  /** Button for student two. */
  private Button buttonTwo;
  /** Button for student three. */
  private Button buttonThree;
  /** Button for student four. */
  private Button buttonFour;
  /** Button for student five. */
  private Button buttonFive;
  /** Button for student six. */
  private Button buttonSix;
  /** Shows the average wait. */
  private TextField averageDisplay;
  /** Advances the clock one minute. */
  private Button tick;
  
  /**
    Initializes the Applet.
    Positions the components and creates all the students.
  */
  public void init () {
  	final int X_START = 40;
  	final int Y_START = 60;
  	final int Y_GAP = 100;
  	final int X_GAP = 130;
  	final int WIDTH = 60;
  	final int HEIGHT = 20;
  	
    setLayout(null);
    setBackground(Color.white);
    
    Label waitingTime = new Label("Average waiting time");
    waitingTime.setBounds(90, 210, 140, 20);
    add(waitingTime);
    
    averageDisplay = new TextField ("0");
    averageDisplay.setBounds(230, 210, 50, 20);
    add(averageDisplay);
    
    tick = new Button ("tick");
		tick.setBounds(175, 20, 50, 20);
    add (tick);
    tick.addActionListener(this);
    
    one = new Student(1, X_START, Y_START);
    buttonOne = new Button("student "+1);
    buttonOne.setBounds(X_START, Y_START, WIDTH, HEIGHT);
    add(buttonOne);
    buttonOne.addActionListener(this);
    
    two = new Student(2, X_START+X_GAP, Y_START);
    buttonTwo = new Button("student "+2);
    buttonTwo.setBounds(X_START+X_GAP, Y_START, WIDTH, HEIGHT);
    add(buttonTwo);
    buttonTwo.addActionListener(this);
    
    three = new Student(3, X_START+2*X_GAP, Y_START);
    buttonThree = new Button("student "+3);
    buttonThree.setBounds(X_START+2*X_GAP, Y_START, WIDTH, HEIGHT);
    add(buttonThree);
    buttonThree.addActionListener(this);

    four = new Student(4, X_START, Y_START+Y_GAP);
    buttonFour = new Button("student "+4);
    buttonFour.setBounds(X_START, Y_START+Y_GAP, WIDTH, HEIGHT);
    add(buttonFour);
    buttonFour.addActionListener(this);

    five = new Student(5, X_START+X_GAP, Y_START+Y_GAP);
    buttonFive = new Button("student "+5);
    buttonFive.setBounds(X_START+X_GAP, Y_START+Y_GAP, WIDTH, HEIGHT);
    add(buttonFive);
    buttonFive.addActionListener(this);

    six = new Student(6, X_START+2*X_GAP, Y_START+Y_GAP);
    buttonSix = new Button("student "+6);
    buttonSix.setBounds(X_START+2*X_GAP, Y_START+Y_GAP, WIDTH, HEIGHT);
    add(buttonSix);
    buttonSix.addActionListener(this);
	}

  /**
    Sends a clock tick to all the students.
  */
	private void tickAllStudents () {
    one.tick();
    two.tick();
    three.tick();
    four.tick();
    five.tick();
    six.tick();
    System.out.println();
  }
  
  /**
    Notifies each student if the demonstrator has arrived.
    @param studentButton the Button clicked on by the user
  */
  private void arriveOrLeave(Button studentButton) {
  	if (studentButton == buttonOne)
  		one.demonstratorArrives();
  	else
  		one.demonstratorLeaves();
  	if (studentButton == buttonTwo)
  		two.demonstratorArrives();
  	else
  		two.demonstratorLeaves();
  	if (studentButton == buttonThree)
  		three.demonstratorArrives();
  	else
  		three.demonstratorLeaves();
  	if (studentButton == buttonFour)
  		four.demonstratorArrives();
  	else
  		four.demonstratorLeaves();
  	if (studentButton == buttonFive)
  		five.demonstratorArrives();
  	else
  		five.demonstratorLeaves();
  	if (studentButton == buttonSix)
  		six.demonstratorArrives();
  	else
  		six.demonstratorLeaves();
	}  	
  		
  /**
    Calculates the average waiting time for all students.
    @return the average waiting time
  */
  private double averageWait() {
    int total = one.currentWait() + two.currentWait() + three.currentWait() +
      four.currentWait() + five.currentWait() + six.currentWait();
    return total/6.0;
  }

  /**
    Handles all of the Button presses.
    @param e the ActionEvent
  */
  public void actionPerformed(ActionEvent e) {
    Button source = (Button)e.getSource();
    if (source == tick) {
    	tickAllStudents();
      averageDisplay.setText(""+averageWait());
    }
    else 
    	arriveOrLeave(source);
    repaint();
  }
  
  /**
    Asks each of the Students to draw themselves.
    @param g the Graphics object
  */
  public void paint(Graphics g) {
  	one.draw(g);
  	two.draw(g);
  	three.draw(g);
  	four.draw(g);
  	five.draw(g);
  	six.draw(g);
  }
}